<Cabbage>
form caption("Diskin File Player") size(1025, 310), pluginId("DkPl")
image bounds(  0,  0,1025, 310), colour( 70, 30, 30), shape("sharp"), outlineColour("White"), line(3)    ; main panel colouration    

soundfiler bounds(4, 4, 1015, 140), channel("beg","len"), identChannel("filer1"),  colour(0, 255, 255, 255), fontColour(160, 160, 160, 255)
label bounds(6, 4, 560, 14), text(""), align(left), colour(0,0,0,0), fontColour(200,200,200), identChannel("stringbox")
s
filebutton bounds(  5,185, 80, 22), text("Open File","Open File"), fontColour("white") channel("filename"), shape("ellipse")
checkbox   bounds(  5,220, 95, 22), channel("PlayStop"), text("Play/Stop"), fontColour:0("white"), fontColour:1("white")
label      bounds(  5,243,115, 10), text("[or right-click-and-drag]"), fontColour("white")
checkbox   bounds(  5,260,100, 22), channel("freeze"), text("Freeze"), colour("LightBlue"), fontColour:0("white"), fontColour:1("white")


rslider    bounds(482, 168, 90, 90), channel("Speed"),    range(0, 100, 0.01, 0.5, 0.001), text("speed"), $SliderStyleI
rslider    bounds(374, 170, 90, 90), channel("Grainrate"), text("Grainrate"), range(0.01, 100, 0.05, 0.5, 0.0001), $SliderStyleK 
rslider    bounds(148, 172, 90, 90), channel("AttTim"),    range(0, 5, 0.01, 0.5, 0.001), text("Att. Time"), $SliderStyleI
rslider    bounds(262, 172, 90, 90), channel("RelTim"),    range(0.01, 5, 0.05, 0.5, 0.001), text("Rel. Time"), $SliderStyleI

</Cabbage>
<CsoundSynthesizer>
<CsOptions>
-n -+rtmidi=NULL -M0 -dm0
</CsOptions>
<CsInstruments>
sr = 44100
ksmps = 64
nchnls = 2
0dbfs = 1


giSine ftgen 0,0,65536,10,1
giCosine ftgen 0,0,8193,9,1,1,90
giSigmoRise ftgen 0,0,8193,19,0.5,1,270,1
giSigmoFall ftgen 0,0,8193,19,0.5,1,90,1
giPan		ftgen	0, 0, 32768, -21, 1		; for panning (random values between 0 and 1)

              ;massign    0,3
gichans        init       0
giFileLen      init       0
giReady        init       0
gSfilepath     init       ""

instr 1
kporttime      linseg     0,0.001,0.02
 gkPlayStop     chnget     "PlayStop"
 gkfreeze       chnget     "freeze"
 gkfreeze       =          1-gkfreeze
; knobs
gkspeed chnget "Speed";
gkgrainrate  chnget "Grainrate";p5; gSfilepath     chnget     "filename"
gigrainsize = 15;p6;
  gicent = 0; p7 transpositionin cent
  giposrand = 400 ;p8 ; time position randomness (offset) of the pointer in ms
  gicentrand = 0;  p9 transposition randomness in cents
  gipan = 0;p10; panning narrow(0) to wide(1) 
  gidist			= 0.5;p11		; grain distribution (0=periodic, 1=scattered)
  gkenv2amt = 0;no secondary enveloping
  gienv2tab = -1; default secondary envelope
  gienv_attack = giSigmoRise;  attack envelope
  gienv_decay = giSigmoFall; decay envelope
  gksustain_amount = 0; time(infraction of grain duration) as sustain level for each  grain.
  gka2dratio = 0.5; balance between attack and decay

  gigainmask = -1; no gain masking 

  /*transposition*/
  gkcentrand rand gicentrand; random transposition

  /*other pitch related params(disabled)*/
  gksweepshape =0 ; no frequency sweep
  giwavfreqstarttab = -1; default frequency sweep start
  giwavfreqendtab = -1; default frequency sweep
  gawavfm = 0; no FM input
  gifmamptab = -1; default FM scaling (=-1)
  gkfmenv = -1 ; default FM envelope(flat)

  /*trainlet related params(disabled)*/
  gicosine = giCosine; cosine ftable
  gkTrainCps = gkgrainrate; set trainlet cps equal to grain rate for single-cycle trainlet in each grain 
  gknumpartials = 1; number of partials in trainlet
  gkchroma  = 1; 

  /*pannings, using channel mask*/
  gimid = .5; center
  gileftmost = gimid - gipan/2
  girightmost = gimid + gipan/2
  giPanthis ftgen 0, 0, 32768, -24, giPan, gileftmost, girightmost; gipan according to ipan
     tableiw  0, 0, giPanthis; change index 0
     tableiw 32766, 1, giPanthis; and 1 for ichannelmasks
  gichannelmasks = giPanthis; ftable for panning

  /*random gain masking (disabled)*/
  gkrandommask = 0;
 gasync =0
;  /*source waveforms*/
  giwaveamptab		= -1		; (default) equal mix of source waveforms and no amplitude for trainlets

  /*original key for each source waveform*/
  gkwavekey1		= 1
  gkwavekey2		= gkwavekey1	
  gkwavekey3		= gkwavekey1
  gkwavekey4		= gkwavekey1

  /* maximum number of grains per k-period*/
  gimax_grains		= 100
  	
 kNewFileTrg    changed    gSfilepath    ; if a new file is loaded generate a trigger
 if kNewFileTrg==1 then                 ; if a new file has been loaded...
                event      "i",99,0,0    ; call instrument to update sample storage function table 
 endif  

 ktrig         trigger    gkPlayStop,0.5,0
               schedkwhen ktrig,0,0,2,0,-1
 
endin       
 
       
             
                         
 instr    99    ; load sound file
 gichans       filenchnls gSfilepath                ; derive the number of channels (mono=1,stereo=2) in the sound file
 giFileLen     filelen    gSfilepath                ; derive the number of channels (mono=1,stereo=2) in the sound file
 gitableL      ftgen      1,0,0,1,gSfilepath,0,0,1
 /*source waveforms*/
  gkwaveform1		= gitableL	; source waveform
  gkwaveform2		= gitableL	; all 4 sources are the same
  gkwaveform3		= gitableL
  gkwaveform4		= gitableL
  
  giorig = 1/ giFileLen; original pitch
  gkwavfreq = giorig * cent(gicent + gkcentrand)
  
  /*timepointers*/ 
  gafilposphas phasor gkspeed / giFileLen 

  /*generate random deviaton of the time pointer*/
  giposrandsec = giposrand / 1000 ; ms -> sec
  giposrand = giposrandsec / giFileLen  ; phase value (0-1)
  gkrndpos linrand giposrand; ranodm offset in phase values

  /*add random deviation to the time pointer*/
  gasamplepos1		= gafilposphas + gkrndpos; resulting phase values (0-1)
  gasamplepos2		= gasamplepos1
  gasamplepos3		= gasamplepos1	
  gasamplepos4		= gasamplepos1

 giReady       =          1                         ; if no string has yet been loaded giReady will be zero

 Smessage      sprintfk   "file(%s)", gSfilepath
               chnset     Smessage, "filer1"    

endin



instr    2    ; triggered by 'play/stop' button
 if gkPlayStop==0 then
               turnoff
 endif
 
 if giReady = 1 then                              ; i.e. if a file has been loaded
  iAttTim      chnget     "AttTim"                ; read in widgets
  iRelTim      chnget     "RelTim"
  
  if iAttTim>0 then                               ; is amplitude envelope attack time is greater than zero...
   kenv        linsegr    0,iAttTim,1,iRelTim,0   ; create an amplitude envelope with an attack, a sustain and a release segment (senses realtime release)
  else            
   kenv        linsegr    1,iRelTim,0             ; create an amplitude envelope with a sustain and a release segment (senses realtime release)
  endif
  
  kenv         expcurve   kenv,8                  ; remap amplitude value with a more natural curve
  aenv         interp     kenv                    ; interpolate and create a-rate envelope
  
 
  
  if changed:k(gkspeed)==1 then
   reinit UPDATE
  endif
  
  UPDATE:
 
  aL, aR partikkel gkgrainrate, gidist, -1, gasync, gkenv2amt, gienv2tab, gienv_attack, gienv_decay,
    gksustain_amount, gka2dratio, gigrainsize, 0.5, gigainmask, gkwavfreq,gksweepshape, 
    giwavfreqstarttab, giwavfreqendtab, gawavfm, gifmamptab,gkfmenv,gicosine, gkTrainCps, 
    gknumpartials, gkchroma, gichannelmasks, gkrandommask,  gkwaveform1, gkwaveform2, 
    gkwaveform3, gkwaveform4,giwaveamptab, gasamplepos1, gasamplepos2, gasamplepos3, 
    gasamplepos4,gkwavekey1, gkwavekey2, gkwavekey3, gkwavekey4, gimax_grains
  aL *= aenv
  aR *= aenv	
     outs aL, aR 

  rireturn
  endif

endin
 
</CsInstruments>
<CsScore>
;causes Csound to run for about 7000 years...
i1 0 z

</CsScore>
</CsoundSynthesizer>
